function C=genebye(A,B,fun)
% function C=genebye(A,B)
%   element by element generic function
%   fun is either @times, @power, @rdivide or @ldivide
  assert(sum(strcmp(func2str(fun),{'times','power','rdivide','ldivide'}))==1)
  [getA,getB,dim]=fc_linalg3D.getComps(A,B);
  if max(size(A))==1 || max(size(B))==1, C=fun(A,B);return;end % A or B is constant (to improve performance)
  if fc_linalg3D.is3Darray(A) && fc_linalg3D.is3Darray(B), C=fun(A,B);return;end % A or B is constant (to improve performance)
  N=dim(1);m=dim(2);n=dim(3);
  C=zeros(N,m,n);
  for i=1:m
    for j=1:n
        C(:,i,j)=fun(getA(A,i,j),getB(B,i,j));
    end
  end
end
